#include "SocketC.h"

//ʼsocket
bool SocketC::initSocket()
{
	//ʼ׽ֿ
	WORD w_req = MAKEWORD(2, 2);//汾
	WSADATA wsadata;
	int err;
	err = WSAStartup(w_req, &wsadata);
	if (err != 0)
	{
		return false;
	}
	//汾
	if (LOBYTE(wsadata.wVersion) != 2 || HIBYTE(wsadata.wHighVersion) != 2)
	{
		WSACleanup();
		return false;
	}
	else
	{
		return true;
	}
}

//
SocketC::SocketC(int mode)
{
	m_mode = mode;
}

//
SocketC::~SocketC()
{
	if (state == 1)
	{
		Close();
	}
}

//ӵ
bool SocketC::Connect(string IP, UINT Prot)
{
	if (!initSocket())
	{//ʼʧ
		return false;
	}
	struct addrinfo* answer, hint;
	char ipstr[16] = { 0 };
	ZeroMemory(&hint, sizeof(hint));
	hint.ai_family = AF_INET;
	hint.ai_socktype = SOCK_STREAM;
	SOCKADDR_IN server_addr;
	//IP
	if (getaddrinfo(IP.c_str(), NULL, &hint, &answer) == 0)
	{
		server_addr.sin_family = AF_INET;
		server_addr.sin_addr.S_un.S_addr = ((struct sockaddr_in*)(answer->ai_addr))->sin_addr.S_un.S_addr;
		server_addr.sin_port = htons(Prot);
		((SOCKADDR_IN*)&hint.ai_addr)->sin_port = htons(Prot);

		//׽
		sclient = socket(AF_INET, SOCK_STREAM, 0);
		//ӵ
		if (connect(sclient, (SOCKADDR*)&server_addr, sizeof(SOCKADDR)) == SOCKET_ERROR)
		{//ʧ
			WSACleanup();
			return false;
		}
		else
		{//ӳɹ߳̽
			state = 1;
			rec = std::thread((&SocketC::Receive), this);
			return true;
		}
	}
	return FALSE;
}

//ݺ
VOID SocketC::Receive()
{
	char* buff = NULL;
	while(state)
	{
		//ʼ
		char buf[1024] = { 0 };
		int len = recv(sclient, buf, 1020, 0);
		if (len ==SOCKET_ERROR || len == 0)
		{//ر
			state = 0;
			if (Cfunc != NULL)
			{
				Cfunc();
			}
			//cout << "Ͽ";
			break;
		}
		if (m_mode == 0)
		{//ͨģʽֱӴ
			if (Rfunc != NULL)
				Rfunc(buf, len);
		}
		else if (m_mode == 1)
		{//յݱճ
			int isStr;
			buff = RecvBuff(buf, len, isStr);
			while (buff)
			{
				if (Rfunc != NULL)
				{
					if (isStr == 1)
					{//ַȽ
						AES aes;
						string str = aes.DecryptionAES(buff, "qwertyuiopasdfgh");
						Rfunc((char*)str.c_str(), str.length());
					}
					else
						Rfunc(buff, len);
				}
				len = 0;
				ZeroMemory(buff, 10001);
				buff = RecvBuff(NULL, len, isStr);
			}
		}
	}
	return;
}

//յ
char* SocketC::RecvBuff(char* buf, int& len, int& isStr)
{
	MsgHead* h;
	//lock_guard<std::mutex> guard(msgLock);
	//յݸƵ
	if (len != 0)
		memcpy_s(tmpBuf + bufLen, len, buf, len);
	bufLen += len;
	//жϻڵϢǷϢͷ
	if (bufLen > sizeof(MsgHead))
	{//Ϣͷ
		h = (MsgHead*)tmpBuf;
		if (!CheckHead(h))
		{//ϢͷϹر
			closesocket(sclient);
			return NULL;
		}
		//жϵǰϢǷ
		if (bufLen - sizeof(MsgHead) >= h->bufLen)
		{//ǰϢ
			memcpy_s(buff, h->bufLen, tmpBuf + sizeof(MsgHead), h->bufLen);
			len = h->bufLen;
			isStr = h->isStr;
			bufLen = bufLen - len - sizeof(MsgHead);
			//ǰ
			if (bufLen > 0)
				memcpy_s(tmpBuf, bufLen, tmpBuf + sizeof(MsgHead) + len, bufLen);
			return buff;
		}
	}
	return NULL;
}

//Ϣͷ
BOOL SocketC::CheckHead(MsgHead* h)
{
	//ϢȲܴ10000
	if (h->bufLen > 10000)
	{
		return FALSE;
	}
	//ݲ֤TokenǷȷ
	string str, str1;
	str = to_string(h->tm);
	str += to_string(h->bufLen);
	md5 md;
	str1 = md.StringToMD5(str);
	str = h->token;
	if (str == str1)
	{//tokenȷ֤Ϣʱ
		time_t t1;
		time(&t1);
		if (abs(t1 - h->tm) < 300)
		{
			return TRUE;
		}
	}
	return FALSE;
}

//ݰ
int SocketC::SendData(const char* Data, int len, int isStr)
{
	if (Data == NULL)
		return -1;
	if (m_mode == 0)
	{//ͨģʽֱӷ
		return send(sclient, Data, len, 0);
	}
	else if (m_mode == 1)
	{//token
		MsgHead h;
		h.isStr = isStr;
		h.bufLen = len;
		time(&h.tm);
		string str = to_string(h.tm);
		str += to_string(len);
		md5 md;
		str = md.StringToMD5(str);
		memcpy_s(h.token, str.length(), str.c_str(), str.length());
		char* buff = new char[sizeof(MsgHead) + len];
		memcpy_s(buff, sizeof(MsgHead), &h, sizeof(MsgHead));
		memcpy_s(buff + sizeof(MsgHead), len, Data, len);
		//
		int lenth = send(sclient, buff, len + sizeof(MsgHead), 0) - sizeof(MsgHead);
		delete[] buff;
		if (lenth < 0)
		{
			lenth = -1;
		}
		return lenth;
	}
}

//ַ
BOOL SocketC::SendStr(string str)
{
	if (str == "")
		return FALSE;
	if (m_mode == 0)
	{//ͨģʽֱӷ
		if (send(sclient, str.c_str(), str.length(), 0) == -1)
		{
			return FALSE;
		}
	}
	else if (m_mode == 1)
	{//ܷ͵ַ
		AES aes;
		string sendStr = aes.EncryptionAES(str, "qwertyuiopasdfgh");
		if (-1 == SendData(sendStr.c_str(), sendStr.length(), 1))
		{
			return FALSE;
		}
	}
	return TRUE;
}

//ýݵĻص
VOID SocketC::SetRecvFunc(function<VOID(char*, int)> fun)
{
	Rfunc = fun;
}

//öϿӵĻص
VOID SocketC::SetCloseFunc(function<VOID()> fun)
{
	Cfunc = fun;
}

//Ͽ
void SocketC::Close()
{
	if (state != 0)
	{
		state = 0;
		//ر׽
		shutdown(sclient, SD_BOTH);
		closesocket(sclient);
		//ͷDLLԴ
		rec.join();
	}
	WSACleanup();
}
